<template>
  <div>
    <chat-header></chat-header>
    <p> Room: {{ room }}</p>
    <p> Chat name: {{ chat_name }}</p>
    <p> Profile uid: {{ uid }}</p>
    <chat-messages :messages="messages"></chat-messages>
    <q-btn @click="changeChatNameByMutation('name via mutation1')">Change name via mutation1</q-btn>
    <q-btn @click="$store.commit('chat/CHANGE_CHAT_NAME', 'new name via mutation2')">Change name via mutation2</q-btn>
    <q-btn @click="changeNameByAction">Change name via action</q-btn>
    <!--<q-btn @click="socketIoEmitMessage">Socket IO Send Message</q-btn>-->
    <q-btn @click="pushToChannel">Phoenix Send Message</q-btn>
  </div>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';
import ChatHeader from './components/ChatHeader.vue';
import ChatMessages from './components/ChatMessages.vue';

const SOCKET_CHAT = 'chat'

export default {
  name: 'chat',
  components: {
    ChatHeader,
    ChatMessages,
  },
  props: {
    uid: {
      default: '4343',
      type: String,
    },
    room: {
      default: '',
      type: String,
    },
    isActive: Boolean,
  },
  data() {
    return {
      messages: [],
    }
  },
  computed: {
    ...mapState('chat', ['chat_name']),
  },
  beforeCreate() {
    // this.$vuePhoenix.joinChannel('room:lobby'); --- join to channel dynamically
  },
  methods: {
    ...mapMutations({
      changeChatNameByMutation: 'chat/CHANGE_CHAT_NAME',
    }),
    ...mapActions({
      changeNameByAction: 'chat/changeChatName',
    }),
    // socketIoEmitMessage() {
    //   this.$socket.emit('chat', {
    //     contents: 'test socket.io message',
    //     username: 'Max',
    //     time: '17:10',
    //     _id: Math.random().toString(36).substring(7)
    //   });
    // },
    pushToChannel() {
      this.$vuePhoenix.pushToChannel('room:lobby', 'shout', {
        message: 'Phoenix hello!',
        sender: 'Sender1',
      });
    },
  },
  channels: {
    'room:lobby': {
      join() {
        console.log("Joined lobby channel room:lobby");
      },
      shout(data) {
        this.messages.push(data.payload);
      },
    },
  },
  beforeDestroy() {
    // this.$vuePhoenix.leaveChannel('room:lobby') --- leave channel dynamically
  },
  // sockets: {
  //   connect() {
  //     console.log('socket connected')
  //   },
  //   [SOCKET_CHAT]({ contents }) {
  //     this.messages.push({ message: contents });
  //   },
  // },
};
</script>

<style lang="stylus" scoped>
  div
    margin 20px
    border 2px solid lightblue
</style>
